/[gentoo-x86]/eclass/webapp.eclass
Gentoo

Diff of /eclass/webapp.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.21 Revision 1.43
1# Copyright 1999-2004 Gentoo Technologies, Inc. 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.21 2004/05/25 10:22:02 stuart Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.43 2006/07/10 00:52:34 rl03 Exp $
4# 4#
5# eclass/webapp.eclass 5# eclass/webapp.eclass
6# Eclass for installing applications to run under a web server 6# Eclass for installing applications to run under a web server
7# 7#
8# Part of the implementation of GLEP #11 8# Part of the implementation of GLEP #11
9# 9#
10# Author(s) Stuart Herbert <stuart@gentoo.org> 10# Author(s) Stuart Herbert <stuart@gentoo.org>
11# Renat Lumpau <rl03@gentoo.org>
12# Gunnar Wrobel <wrobel@gentoo.org>
11# 13#
12# ------------------------------------------------------------------------ 14# ------------------------------------------------------------------------
13# 15#
14# The master copy of this eclass is held in Stu's subversion repository. 16# The master copy of this eclass is held in our subversion repository.
17# http://svn.gnqs.org/projects/vhost-tools/browser/
15# 18#
16# If you make changes to this file and don't tell Stu, chances are that 19# If you make changes to this file and don't tell us, chances are that
17# your changes will be overwritten the next time Stu releases a new version 20# your changes will be overwritten the next time we release a new version
18# of webapp-config. 21# of webapp-config.
19# 22#
20# ------------------------------------------------------------------------ 23# ------------------------------------------------------------------------
21 24
22ECLASS=webapp
23INHERITED="$INHERITED $ECLASS"
24SLOT="${PVR}" 25SLOT="${PVR}"
25IUSE="$IUSE vhosts" 26IUSE="vhosts"
26DEPEND="$DEPEND >=net-www/webapp-config-1.7 app-portage/gentoolkit" 27DEPEND="app-admin/webapp-config"
28RDEPEND="${DEPEND}"
27 29
28EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm 30EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm
29 31
30INSTALL_DIR="/$PN" 32INSTALL_DIR="/${PN}"
31IS_UPGRADE=0 33IS_UPGRADE=0
32IS_REPLACE=0 34IS_REPLACE=0
33 35
34INSTALL_CHECK_FILE="installed_by_webapp_eclass" 36INSTALL_CHECK_FILE="installed_by_webapp_eclass"
35 37
36ETC_CONFIG="/etc/vhosts/webapp-config" 38ETC_CONFIG="${ROOT}/etc/vhosts/webapp-config"
39WEBAPP_CONFIG="${ROOT}/usr/sbin/webapp-config"
40
41# ------------------------------------------------------------------------
42# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY
43#
44# Load the config file /etc/vhosts/webapp-config
45#
46# Supports both the old bash version, and the new python version
47#
48# ------------------------------------------------------------------------
49
50function webapp_read_config ()
51{
52 if has_version '>=app-admin/webapp-config-1.50'; then
53 ENVVAR=$(${WEBAPP_CONFIG} --query ${PN} ${PVR}) || die "Could not read settings from webapp-config!"
54 eval ${ENVVAR}
55 else
56 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}"
57 fi
58}
37 59
38# ------------------------------------------------------------------------ 60# ------------------------------------------------------------------------
39# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY 61# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY
40# 62#
41# Check whether a specified file exists within the image/ directory 63# Check whether a specified file exists within the image/ directory
48 70
49function webapp_checkfileexists () 71function webapp_checkfileexists ()
50{ 72{
51 local my_prefix 73 local my_prefix
52 74
53 [ -n "$2" ] && my_prefix="$2/" || my_prefix= 75 [ -n "${2}" ] && my_prefix="${2}/" || my_prefix=
54 76
55 if [ ! -e ${my_prefix}$1 ]; then 77 if [ ! -e "${my_prefix}${1}" ]; then
56 msg="ebuild fault: file $1 not found" 78 msg="ebuild fault: file '${1}' not found"
57 eerror "$msg" 79 eerror "$msg"
58 eerror "Please report this as a bug at http://bugs.gentoo.org/" 80 eerror "Please report this as a bug at http://bugs.gentoo.org/"
59 die "$msg" 81 die "$msg"
60 fi 82 fi
61} 83}
66 88
67function webapp_check_installedat 89function webapp_check_installedat
68{ 90{
69 local my_output 91 local my_output
70 92
71 /usr/sbin/webapp-config --show-installed -h localhost -d $INSTALL_DIR 2> /dev/null 93 ${WEBAPP_CONFIG} --show-installed -h localhost -d "${INSTALL_DIR}" 2> /dev/null
72} 94}
73 95
74# ------------------------------------------------------------------------ 96# ------------------------------------------------------------------------
75# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY 97# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY
76# ------------------------------------------------------------------------
77
78function webapp_import_config ()
79{
80 if [ -z "${MY_HTDOCSDIR}" ]; then
81 . /etc/conf.d/webapp-config
82 fi
83
84 if [ -z "${MY_HTDOCSDIR}" ]; then
85 libsh_edie "/etc/conf.d/webapp-config not imported"
86 fi
87}
88
89# ------------------------------------------------------------------------
90# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY
91# 98#
92# ------------------------------------------------------------------------ 99# ------------------------------------------------------------------------
93 100
94function webapp_strip_appdir () 101function webapp_strip_appdir ()
95{ 102{
96 local my_stripped="$1" 103 local my_stripped="${1}"
97 echo "$1" | sed -e "s|${MY_APPDIR}/||g;" 104 echo "${1}" | sed -e "s|${MY_APPDIR}/||g;"
98} 105}
99 106
100function webapp_strip_d () 107function webapp_strip_d ()
101{ 108{
102 echo "$1" | sed -e "s|${D}||g;" 109 echo "${1}" | sed -e "s|${D}||g;"
103} 110}
104 111
105function webapp_strip_cwd () 112function webapp_strip_cwd ()
106{ 113{
107 local my_stripped="$1" 114 local my_stripped="${1}"
108 echo "$1" | sed -e 's|/./|/|g;' 115 echo "${1}" | sed -e 's|/./|/|g;'
109} 116}
110 117
111# ------------------------------------------------------------------------ 118# ------------------------------------------------------------------------
112# EXPORTED FUNCTION - FOR USE IN EBUILDS 119# EXPORTED FUNCTION - FOR USE IN EBUILDS
113# 120#
116# @param $1 - config file 123# @param $1 - config file
117# ------------------------------------------------------------------------ 124# ------------------------------------------------------------------------
118 125
119function webapp_configfile () 126function webapp_configfile ()
120{ 127{
128 local m=""
129 for m in "$@" ; do
121 webapp_checkfileexists "$1" "$D" 130 webapp_checkfileexists "${m}" "${D}"
122 echo $1 131
123 local MY_FILE="`webapp_strip_appdir $1`" 132 local MY_FILE="$(webapp_strip_appdir "${m}")"
124 echo $MY_FILE 133 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")"
125 134
126 einfo "(config) $MY_FILE" 135 elog "(config) ${MY_FILE}"
127 echo "$MY_FILE" >> ${D}${WA_CONFIGLIST} 136 echo "${MY_FILE}" >> ${D}/${WA_CONFIGLIST}
137 done
128} 138}
129 139
130# ------------------------------------------------------------------------ 140# ------------------------------------------------------------------------
131# EXPORTED FUNCTION - FOR USE IN EBUILDS 141# EXPORTED FUNCTION - FOR USE IN EBUILDS
132# 142#
136# @param $1 - the script to run 146# @param $1 - the script to run
137# ------------------------------------------------------------------------ 147# ------------------------------------------------------------------------
138 148
139function webapp_hook_script () 149function webapp_hook_script ()
140{ 150{
141 webapp_checkfileexists "$2" 151 webapp_checkfileexists "${1}"
142 152
143 einfo "(hook) $1" 153 elog "(hook) ${1}"
144 cp "$1" "${D}${MY_HOOKSCRIPTSDIR}/`basename $1`" || die "Unable to install $1 into ${D}${MY_HOOKSCRIPTSDIR}/" 154 cp "${1}" "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")" || die "Unable to install ${1} into ${D}/${MY_HOOKSCRIPTSDIR}/"
145 chmod 555 "${D}${MY_HOOKSCRIPTSDIR}/`basename $1`" 155 chmod 555 "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")"
146} 156}
147 157
148# ------------------------------------------------------------------------ 158# ------------------------------------------------------------------------
149# EXPORTED FUNCTION - FOR USE IN EBUILDS 159# EXPORTED FUNCTION - FOR USE IN EBUILDS
150# 160#
152# 162#
153# @param $1 - language code (use 'en' for now) 163# @param $1 - language code (use 'en' for now)
154# @param $2 - the file to install 164# @param $2 - the file to install
155# ------------------------------------------------------------------------ 165# ------------------------------------------------------------------------
156 166
157function webapp_postinst_txt 167function webapp_postinst_txt ()
158{ 168{
159 webapp_checkfileexists "$2" 169 webapp_checkfileexists "${2}"
160 170
161 einfo "(rtfm) $2 (lang: $1)" 171 elog "(info) ${2} (lang: ${1})"
162 cp "$2" "${D}${MY_APPDIR}/postinst-$1.txt" 172 cp "${2}" "${D}/${MY_APPDIR}/postinst-${1}.txt"
163} 173}
164 174
165# ------------------------------------------------------------------------ 175# ------------------------------------------------------------------------
166# EXPORTED FUNCTION - FOR USE IN EBUILDS 176# EXPORTED FUNCTION - FOR USE IN EBUILDS
167# 177#
168# Identify a script file (usually, but not always PHP or Perl) which is 178# Install a text file containing post-upgrade instructions.
169# 179#
170# Files in this list may be modified to #! the required CGI engine when 180# @param $1 - language code (use 'en' for now)
171# installed by webapp-config tool in the future. 181# @param $2 - the file to install
172#
173# @param $1 - the cgi engine to use
174# @param $2 - the script file that could run under a cgi-bin
175#
176# ------------------------------------------------------------------------ 182# ------------------------------------------------------------------------
177 183
178function webapp_runbycgibin () 184function webapp_postupgrade_txt ()
179{ 185{
180 webapp_checkfileexists "$2" "$D" 186 webapp_checkfileexists "${2}"
181 local MY_FILE="`webapp_strip_appdir $2`"
182 MY_FILE="`webapp_strip_cwd $MY_FILE`"
183 187
184 einfo "(cgi-bin) $1 - $MY_FILE" 188 elog "(info) ${2} (lang: ${1})"
185 echo "$1 $MY_FILE" >> ${D}${WA_RUNBYCGIBINLIST} 189 cp "${2}" "${D}/${MY_APPDIR}/postupgrade-${1}.txt"
186} 190}
187 191
188# ------------------------------------------------------------------------ 192# ------------------------------------------------------------------------
189# EXPORTED FUNCTION - FOR USE IN EBUILDS 193# EXPORTED FUNCTION - FOR USE IN EBUILDS
190# 194#
191# Identify a file which must be owned by the webserver's user:group 195# Identify a file which must be owned by the webserver's user:group
192# settings. 196# settings.
193# 197#
194# The ownership of the file is NOT set until the application is installed 198# The ownership of the file is NOT set until the application is installed
195# using the webapp-config tool. 199# using the webapp-config tool.
196# 200#
197# @param $1 - file to be owned by the webserver user:group combo 201# @param $1 - file to be owned by the webserver user:group combo
198# 202#
199# ------------------------------------------------------------------------ 203# ------------------------------------------------------------------------
200 204
201function webapp_serverowned () 205function webapp_serverowned ()
202{ 206{
207 local a=""
208 local m=""
209 if [ "${1}" = "-R" ]; then
210 shift
211 for m in "$@" ; do
212 for a in $(find ${D}/${m}); do
213 a=${a/${D}\/\///}
214 webapp_checkfileexists "${a}" "$D"
215 local MY_FILE="$(webapp_strip_appdir "${a}")"
216 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")"
217
218 elog "(server owned) ${MY_FILE}"
219 echo "${MY_FILE}" >> "${D}/${WA_SOLIST}"
220 done
221 done
222 else
223 for m in "$@" ; do
203 webapp_checkfileexists "$1" "$D" 224 webapp_checkfileexists "${m}" "$D"
204 local MY_FILE="`webapp_strip_appdir $1`" 225 local MY_FILE="$(webapp_strip_appdir "${m}")"
205 226 MY_FILE="$(webapp_strip_cwd "${MY_FILE}")"
227
206 einfo "(server owned) $MY_FILE" 228 elog "(server owned) ${MY_FILE}"
207 echo "$MY_FILE" >> ${D}${WA_SOLIST} 229 echo "${MY_FILE}" >> "${D}/${WA_SOLIST}"
230 done
231 fi
208} 232}
209 233
210# ------------------------------------------------------------------------ 234# ------------------------------------------------------------------------
211# EXPORTED FUNCTION - FOR USE IN EBUILDS 235# EXPORTED FUNCTION - FOR USE IN EBUILDS
212# 236#
219# NOTE: 243# NOTE:
220# this function will automagically prepend $1 to the front of your 244# this function will automagically prepend $1 to the front of your
221# config file's name 245# config file's name
222# ------------------------------------------------------------------------ 246# ------------------------------------------------------------------------
223 247
224function webapp_server_config () 248function webapp_server_configfile ()
225{ 249{
226 webapp_checkfileexists "$2" 250 webapp_checkfileexists "${2}"
227 251
228 # sort out what the name will be of the config file 252 # sort out what the name will be of the config file
229 253
230 local my_file 254 local my_file
231 255
232 if [ -z "$3" ]; then 256 if [ -z "${3}" ]; then
233 $my_file="$1-`basename $2`" 257 my_file="${1}-$(basename "${2}")"
234 else 258 else
235 $my_file="$1-$3" 259 my_file="${1}-${3}"
236 fi 260 fi
237 261
238 # warning: 262 # warning:
239 # 263 #
240 # do NOT change the naming convention used here without changing all 264 # do NOT change the naming convention used here without changing all
241 # the other scripts that also rely upon these names 265 # the other scripts that also rely upon these names
242 266
243 einfo "($1) config file '$my_file'" 267 elog "(${1}) config file '${my_file}'"
244 cp "$2" "${D}${MY_SERVERCONFIGDIR}/${my_file}" 268 cp "${2}" "${D}/${MY_SERVERCONFIGDIR}/${my_file}"
245} 269}
246 270
247# ------------------------------------------------------------------------ 271# ------------------------------------------------------------------------
248# EXPORTED FUNCTION - FOR USE IN EBUILDS 272# EXPORTED FUNCTION - FOR USE IN EBUILDS
249# 273#
256# a new db from scratch) 280# a new db from scratch)
257# ------------------------------------------------------------------------ 281# ------------------------------------------------------------------------
258 282
259function webapp_sqlscript () 283function webapp_sqlscript ()
260{ 284{
261 webapp_checkfileexists "$2" 285 webapp_checkfileexists "${2}"
262 286
263 # create the directory where this script will go 287 # create the directory where this script will go
264 # 288 #
265 # scripts for specific database engines go into their own subdirectory 289 # scripts for specific database engines go into their own subdirectory
266 # just to keep things readable on the filesystem 290 # just to keep things readable on the filesystem
267 291
268 if [ ! -d "${D}${MY_SQLSCRIPTSDIR}/$1" ]; then 292 if [ ! -d "${D}/${MY_SQLSCRIPTSDIR}/${1}" ]; then
269 mkdir -p "${D}${MY_SQLSCRIPTSDIR}/$1" || libsh_die "unable to create directory ${D}${MY_SQLSCRIPTSDIR}/$1" 293 mkdir -p "${D}/${MY_SQLSCRIPTSDIR}/${1}" || die "unable to create directory ${D}/${MY_SQLSCRIPTSDIR}/${1}"
270 fi 294 fi
271 295
272 # warning: 296 # warning:
273 # 297 #
274 # do NOT change the naming convention used here without changing all 298 # do NOT change the naming convention used here without changing all
275 # the other scripts that also rely upon these names 299 # the other scripts that also rely upon these names
276 300
277 # are we dealing with an 'upgrade'-type script? 301 # are we dealing with an 'upgrade'-type script?
278 if [ -n "$3" ]; then 302 if [ -n "${3}" ]; then
279 # yes we are 303 # yes we are
280 einfo "($1) upgrade script from ${PN}-${PVR} to $3" 304 elog "(${1}) upgrade script from ${PN}-${PVR} to ${3}"
281 cp $2 ${D}${MY_SQLSCRIPTSDIR}/$1/${3}_to_${PVR}.sql 305 cp "${2}" "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
306 chmod 600 "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
282 else 307 else
283 # no, we are not 308 # no, we are not
284 einfo "($1) create script for ${PN}-${PVR}" 309 elog "(${1}) create script for ${PN}-${PVR}"
285 cp $2 ${D}${MY_SQLSCRIPTSDIR}/$1/${PVR}_create.sql 310 cp "${2}" "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
311 chmod 600 "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
286 fi 312 fi
287} 313}
288 314
289# ------------------------------------------------------------------------ 315# ------------------------------------------------------------------------
290# EXPORTED FUNCTION - call from inside your ebuild's src_install AFTER 316# EXPORTED FUNCTION - call from inside your ebuild's src_install AFTER
291# everything else has run 317# everything else has run
292# 318#
293# For now, we just make sure that root owns everything, and that there 319# For now, we just make sure that root owns everything, and that there
294# are no setuid files. I'm sure this will change significantly before 320# are no setuid files.
295# the final version!
296# ------------------------------------------------------------------------ 321# ------------------------------------------------------------------------
297 322
298function webapp_src_install () 323function webapp_src_install ()
299{ 324{
300 chown -R ${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID} ${D}/ 325 chown -R "${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID}" "${D}/"
301 chmod -R u-s ${D}/ 326 chmod -R u-s "${D}/"
302 chmod -R g-s ${D}/ 327 chmod -R g-s "${D}/"
303 328
304 keepdir ${MY_PERSISTDIR} 329 keepdir "${MY_PERSISTDIR}"
305 fowners root:root ${MY_PERSISTDIR} 330 fowners "root:0" "${MY_PERSISTDIR}"
306 fperms 755 ${MY_PERSISTDIR} 331 fperms 755 "${MY_PERSISTDIR}"
307 332
308 # to test whether or not the ebuild has correctly called this function 333 # to test whether or not the ebuild has correctly called this function
309 # we add an empty file to the filesystem 334 # we add an empty file to the filesystem
310 # 335 #
311 # we used to just set a variable in the shell script, but we can 336 # we used to just set a variable in the shell script, but we can
312 # no longer rely on Portage calling both webapp_src_install() and 337 # no longer rely on Portage calling both webapp_src_install() and
313 # webapp_pkg_postinst() within the same shell process 338 # webapp_pkg_postinst() within the same shell process
314 339
315 touch ${D}/${MY_APPDIR}/${INSTALL_CHECK_FILE} 340 touch "${D}/${MY_APPDIR}/${INSTALL_CHECK_FILE}"
316} 341}
317 342
318# ------------------------------------------------------------------------ 343# ------------------------------------------------------------------------
319# EXPORTED FUNCTION - call from inside your ebuild's pkg_config AFTER 344# EXPORTED FUNCTION - call from inside your ebuild's pkg_config AFTER
320# everything else has run 345# everything else has run
325 350
326function webapp_pkg_setup () 351function webapp_pkg_setup ()
327{ 352{
328 # add sanity checks here 353 # add sanity checks here
329 354
330 if [ "$SLOT+" != "${PVR}+" ]; then 355 if [ "${SLOT}+" != "${PVR}+" ]; then
356 # special case - some ebuilds *do* need to overwride the SLOT
357 if [ "${WEBAPP_MANUAL_SLOT}" != "yes" ]; then
331 die "ebuild sets SLOT, overrides webapp.eclass" 358 die "ebuild sets SLOT, overrides webapp.eclass"
359 else
360 ewarn
361 ewarn "This ebuild overrides the default SLOT behaviour for webapps"
362 ewarn "If this package installs files into the htdocs dir, this is"
363 ewarn "probably a bug in the ebuild."
364 ewarn
365 fi
332 fi 366 fi
333 367
334 # pull in the shared configuration file 368 # pull in the shared configuration file
335 369
336 G_HOSTNAME="localhost" 370 G_HOSTNAME="localhost"
337 . ${ETC_CONFIG} || die "Unable to open /etc/vhosts/webapp-config file" 371 webapp_read_config
338 372
339 # are we installing a webapp-config solution over the top of a 373 # are we installing a webapp-config solution over the top of a
340 # non-webapp-config solution? 374 # non-webapp-config solution?
341 375
342 if ! use vhosts ; then 376 if ! use vhosts ; then
343 local my_dir="$VHOST_ROOT/$MY_HTDOCSBASE/$PN" 377 local my_dir="${ROOT}${VHOST_ROOT}/${MY_HTDOCSBASE}/${PN}"
344 local my_output 378 local my_output
345 379
346 if [ -d "$my_dir" ] ; then 380 if [ -d "${my_dir}" ] ; then
347 einfo "You already have something installed in $my_dir"
348 einfo "Are you trying to install over the top of something I cannot upgrade?"
349
350 my_output="`webapp_check_installedat`" 381 my_output="$(webapp_check_installedat)"
351 382
352 if [ "$?" != "0" ]; then 383 if [ "$?" != "0" ]; then
353
354 # okay, whatever is there, it isn't webapp-config-compatible 384 # okay, whatever is there, it isn't webapp-config-compatible
385 ewarn "You already have something installed in ${my_dir}"
355 ewarn 386 ewarn
356 ewarn "Whatever is in $my_dir, it's not" 387 ewarn "Whatever is in ${my_dir}, it's not"
357 ewarn "compatible with webapp-config." 388 ewarn "compatible with webapp-config."
358 ewarn 389 ewarn
359 ewarn "This ebuild may be overwriting important files." 390 ewarn "This ebuild may be overwriting important files."
360 ewarn 391 ewarn
361 elif [ "`echo $my_output | awk '{ print $1 }'`" != "$PN" ]; then 392 elif [ "$(echo ${my_output} | awk '{ print $1 }')" != "${PN}" ]; then
362 eerror "$my_dir contains $my_output" 393 eerror "${my_dir} contains ${my_output}"
363 eerror "I cannot upgrade that" 394 eerror "I cannot upgrade that"
364 die "Cannot upgrade contents of $my_dir" 395 die "Cannot upgrade contents of ${my_dir}"
365 else
366 einfo
367 einfo "I can upgrade the contents of $my_dir"
368 einfo
369 fi 396 fi
370 fi 397 fi
371 fi 398 fi
372} 399}
373 400
374function webapp_someunusedfunction ()
375{
376 # are we emerging something that is already installed?
377
378 if [ -d "${D}${MY_APPROOT}/${MY_APPSUFFIX}" ]; then
379 # yes we are
380 ewarn "Removing existing copy of ${PN}-${PVR}"
381 rm -rf "${D}${MY_APPROOT}/${MY_APPSUFFIX}"
382 fi
383}
384
385function webapp_getinstalltype () 401function webapp_getinstalltype ()
386{ 402{
387 # or are we upgrading? 403 # or are we upgrading?
388 404
389 if ! use vhosts ; then 405 if ! use vhosts ; then
390 # we only run webapp-config if vhosts USE flag is not set 406 # we only run webapp-config if vhosts USE flag is not set
391 407
392 local my_output 408 local my_output
393 409
394 my_output="`webapp_check_installedat`" 410 my_output="$(webapp_check_installedat)"
395 411
396 if [ "$?" = "0" ] ; then 412 if [ "${?}" = "0" ] ; then
397 # something is already installed there 413 # something is already installed there
398 # 414 #
399 # make sure it isn't the same version 415 # make sure it isn't the same version
400 416
401 local my_pn="`echo $my_output | awk '{ print $1 }'`" 417 local my_pn="$(echo ${my_output} | awk '{ print $1 }')"
402 local my_pvr="`echo $my_output | awk '{ print $2 }'`" 418 local my_pvr="$(echo ${my_output} | awk '{ print $2 }')"
403 419
404 REMOVE_PKG="${my_pn}-${my_pvr}" 420 REMOVE_PKG="${my_pn}-${my_pvr}"
405 421
406 if [ "$my_pn" == "$PN" ]; then 422 if [ "${my_pn}" == "${PN}" ]; then
407 if [ "$my_pvr" != "$PVR" ]; then 423 if [ "${my_pvr}" != "${PVR}" ]; then
408 einfo "This is an upgrade" 424 elog "This is an upgrade"
409 IS_UPGRADE=1 425 IS_UPGRADE=1
410 else 426 else
411 einfo "This is a re-installation" 427 elog "This is a re-installation"
412 IS_REPLACE=1 428 IS_REPLACE=1
413 fi 429 fi
414 else 430 else
415 einfo "$my_ouptut is installed there" 431 elog "${my_output} is installed there"
416 fi 432 fi
417 else 433 else
418 einfo "This is an installation" 434 elog "This is an installation"
419 fi 435 fi
420 fi 436 fi
421} 437}
422 438
423function webapp_src_preinst () 439function webapp_src_preinst ()
424{ 440{
425 # create the directories that we need 441 # create the directories that we need
426 442
427 dodir ${MY_HTDOCSDIR} 443 dodir "${MY_HTDOCSDIR}"
428 dodir ${MY_HOSTROOTDIR} 444 dodir "${MY_HOSTROOTDIR}"
429 dodir ${MY_CGIBINDIR} 445 dodir "${MY_CGIBINDIR}"
430 dodir ${MY_ICONSDIR} 446 dodir "${MY_ICONSDIR}"
431 dodir ${MY_ERRORSDIR} 447 dodir "${MY_ERRORSDIR}"
432 dodir ${MY_SQLSCRIPTSDIR} 448 dodir "${MY_SQLSCRIPTSDIR}"
449 dodir "${MY_HOOKSCRIPTSDIR}"
450 dodir "${MY_SERVERCONFIGDIR}"
433} 451}
434 452
435function webapp_pkg_postinst () 453function webapp_pkg_postinst ()
436{ 454{
437 . ${ETC_CONFIG} 455 webapp_read_config
438 456
439 # sanity checks, to catch bugs in the ebuild 457 # sanity checks, to catch bugs in the ebuild
440 458
441 if [ ! -f ${MY_APPDIR}/${INSTALL_CHECK_FILE} ]; then 459 if [ ! -f "${ROOT}${MY_APPDIR}/${INSTALL_CHECK_FILE}" ]; then
442 eerror 460 eerror
443 eerror "This ebuild did not call webapp_src_install() at the end" 461 eerror "This ebuild did not call webapp_src_install() at the end"
444 eerror "of the src_install() function" 462 eerror "of the src_install() function"
445 eerror 463 eerror
446 eerror "Please log a bug on http://bugs.gentoo.org" 464 eerror "Please log a bug on http://bugs.gentoo.org"
450 eerror 468 eerror
451 die "Ebuild did not call webapp_src_install() - report to http://bugs.gentoo.org" 469 die "Ebuild did not call webapp_src_install() - report to http://bugs.gentoo.org"
452 fi 470 fi
453 471
454 # if 'vhosts' is not set in your USE flags, we install a copy of 472 # if 'vhosts' is not set in your USE flags, we install a copy of
455 # this application in /var/www/localhost/htdocs/${PN}/ for you 473 # this application in ${ROOT}/var/www/localhost/htdocs/${PN}/ for you
456 474
457 if ! use vhosts ; then 475 if ! use vhosts ; then
458 echo 476 echo
459 einfo "vhosts USE flag not set - auto-installing using webapp-config" 477 elog "vhosts USE flag not set - auto-installing using webapp-config"
460 478
461 webapp_getinstalltype 479 webapp_getinstalltype
462 480
463 G_HOSTNAME="localhost" 481 G_HOSTNAME="localhost"
464 . /etc/vhosts/webapp-config
465
466 local my_mode=-I 482 local my_mode=-I
483 webapp_read_config
467 484
468 if [ "$IS_REPLACE" = "1" ]; then 485 if [ "${IS_REPLACE}" = "1" ]; then
469 einfo "${PN}-${PVR} is already installed - replacing" 486 elog "${PN}-${PVR} is already installed - replacing"
470 /usr/sbin/webapp-config -C -d "$INSTALL_DIR" 487 my_mode=-I
471 elif [ "$IS_UPGRADE" = "1" ]; then 488 elif [ "${IS_UPGRADE}" = "1" ]; then
472 einfo "$REMOVE_PKG is already installed - upgrading" 489 elog "${REMOVE_PKG} is already installed - upgrading"
473 my_mode=-U 490 my_mode=-U
474 else 491 else
475 einfo "${PN}-${PVR} is not installed - using install mode" 492 elog "${PN}-${PVR} is not installed - using install mode"
476 fi 493 fi
477 494
478 my_cmd="/usr/sbin/webapp-config $my_mode -h localhost -u root -d $INSTALL_DIR ${PN} ${PVR}" 495 my_cmd="${WEBAPP_CONFIG} ${my_mode} -h localhost -u root -d ${INSTALL_DIR} ${PN} ${PVR}"
479 einfo "Running $my_cmd" 496 elog "Running ${my_cmd}"
480 $my_cmd 497 ${my_cmd}
481 498
482 # remove the old version 499 # remove the old version
483 # 500 #
484 # why do we do this? well ... 501 # why do we do this? well ...
485 # 502 #
488 # slot to the old version, then the old version gets left behind 505 # slot to the old version, then the old version gets left behind
489 # 506 #
490 # if USE=-vhosts, then we want to remove the old version, because 507 # if USE=-vhosts, then we want to remove the old version, because
491 # the user is relying on portage to do the magical thing for it 508 # the user is relying on portage to do the magical thing for it
492 509
493 if [ "$IS_UPGRADE" = "1" ] ; then 510 if [ "${IS_UPGRADE}" = "1" ] ; then
494 einfo "Removing old version $REMOVE_PKG" 511 elog "Removing old version ${REMOVE_PKG}"
495 512
496 emerge -C $CATEGORY/$REMOVE_PKG 513 emerge -C "${REMOVE_PKG}"
497 fi 514 fi
498 else 515 else
499 # vhosts flag is on 516 # vhosts flag is on
500 # 517 #
501 # let's tell the administrator what to do next 518 # let's tell the administrator what to do next
502 519
503 einfo 520 elog
504 einfo "The 'vhosts' USE flag is switched ON" 521 elog "The 'vhosts' USE flag is switched ON"
505 einfo "This means that Portage will not automatically run webapp-config to" 522 elog "This means that Portage will not automatically run webapp-config to"
506 einfo "complete the installation." 523 elog "complete the installation."
507 einfo 524 elog
508 einfo "To install $PN-$PVR into a virtual host, run the following command:" 525 elog "To install ${PN}-${PVR} into a virtual host, run the following command:"
509 einfo 526 elog
510 einfo " webapp-config -I -h <host> -d $PN $PN $PVR" 527 elog " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}"
511 einfo 528 elog
512 einfo "For more details, see the webapp-config(8) man page" 529 elog "For more details, see the webapp-config(8) man page"
513 fi 530 fi
514 531
515 return 0 532 return 0
516} 533}
517 534
520 # remove any virtual installs that there are 537 # remove any virtual installs that there are
521 538
522 local my_output 539 local my_output
523 local x 540 local x
524 541
525 my_output="`webapp-config --list-installs $PN $PVR`" 542 my_output="$(${WEBAPP_CONFIG} --list-installs ${PN} ${PVR})"
526 543
527 if [ "$?" != "0" ]; then 544 if [ "${?}" != "0" ]; then
528 return 545 return
529 fi 546 fi
530 547
531 # the changes to IFS here are necessary to ensure that we can cope
532 # with directories that contain spaces in the file names
533
534 # OLD_IFS="$IFS"
535 # IFS=" "
536
537 for x in $my_output ; do 548 for x in ${my_output} ; do
538 # IFS="$OLD_IFS"
539
540 [ -f $x/.webapp ] && . $x/.webapp || ewarn "Cannot find file $x/.webapp" 549 [ -f ${x}/.webapp ] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp"
541 550
542 if [ -z "WEB_HOSTNAME" -o -z "WEB_INSTALLDIR" ]; then 551 if [ -z "${WEB_HOSTNAME}" -o -z "${WEB_INSTALLDIR}" ]; then
543 ewarn "Don't forget to use webapp-config to remove the copy of" 552 ewarn "Don't forget to use webapp-config to remove the copy of"
544 ewarn "${PN}-${PVR} installed in" 553 ewarn "${PN}-${PVR} installed in"
545 ewarn 554 ewarn
546 ewarn " $x" 555 ewarn " ${x}"
547 ewarn 556 ewarn
548 else 557 else
549 # we have enough information to remove the virtual copy ourself 558 # we have enough information to remove the virtual copy ourself
550 559
551 webapp-config -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR} 560 ${WEBAPP_CONFIG} -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR}
552 561
553 # if the removal fails - we carry on anyway! 562 # if the removal fails - we carry on anyway!
554 fi 563 fi
555 # IFS=" "
556 done 564 done
557
558 # IFS="$OLD_IFS"
559} 565}

Legend:
Removed from v.1.21  
changed lines
  Added in v.1.43

  ViewVC Help
Powered by ViewVC 1.1.20